var ViewRdf=
{
	RdfService:null,
	DataSource:null,
	strResource:null,
	strPredicate:null,
	strDate:null,
	strInt:null,
	strUnknown:null,
	strLiteral:null,
	strBlob:null,
	strNode:null,
	onLoad:function()
	{
		this.RdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var oBundle = Components.classes['@mozilla.org/intl/stringbundle;1'].getService(Components.interfaces.nsIStringBundleService);
		var strbundle = oBundle.createBundle('chrome://rdfviewer/locale/strings.properties');

		this.strResource=strbundle.GetStringFromName("resource");
		this.strDate=strbundle.GetStringFromName("date");
		this.strPredicate=strbundle.GetStringFromName("predicate");
		this.strLiteral=strbundle.GetStringFromName("literal");
		this.strInt=strbundle.GetStringFromName("int");
		this.strUnknown=strbundle.GetStringFromName("unknown");
		this.strBlob=strbundle.GetStringFromName("blob");
		this.strNode=strbundle.GetStringFromName("node");
	},
	listResource:function()
	{
		var DataSourceUri = document.getElementById("DataSourceUri").value;
		var menulist=document.getElementById("ResourceList");
		menulist.removeAllItems();
		try
		{
			this.DataSource = this.RdfService.GetDataSourceBlocking(DataSourceUri);
		}
		catch(ex)
		{
			alert(document.getElementById("strings").getString("DateError"));
			DataSource=null;
			return;
		}
		var resources=this.DataSource.GetAllResources();	
		var sort=new Array();
		while(resources.hasMoreElements())
		{
			var rsc=resources.getNext();
			if (rsc instanceof Components.interfaces.nsIRDFResource)
			{
				sort.push(rsc.Value)	
			}
		}
		sort.sort();
		for(var i=0; i<sort.length; i++)
		{
			menulist.appendItem(sort[i],"","");
		}
		if(sort.length>0)
		{
			menulist.selectedIndex=0;
		}
	},
	clearTree:function()
	{
		var TreeChildren=document.getElementById("TreeChildren");
		while(TreeChildren.hasChildNodes())
		{
			TreeChildren.removeChild(TreeChildren.childNodes[0]);
		}		
	},
	listTree:function()
	{
		if(this.DataSource!=null)
		{
			var DataSourceUri = document.getElementById("DataSourceUri").value;
			var RootResource = document.getElementById("ResourceList").value;
			var treeview=document.getElementById("TreeView");
			this.clearTree();
			this.appendItem(treeview,RootResource,this.strResource);
		}
	},
	appendItem:function(parent,name, type )
	{
		parent.setAttribute("open","true");
		var children=null;
		for (var i=0; i < parent.childNodes.length; i++)
		{
			if (parent.childNodes[i].nodeName == "treechildren")
			{
				children=parent.childNodes[i];
				break;
			}
		}
		if(children==null)
		{
			children = document.createElement("treechildren");
			parent.appendChild(children);
		}
		var titem = document.createElement("treeitem");
		titem.setAttribute("type",type);
		if(type==this.strResource||type==this.strPredicate)
		{
			titem.setAttribute("container","true");
		}
		var trow = document.createElement("treerow");
		var tcell = document.createElement("treecell");
		tcell.setAttribute("label", name);
		var tcelltype = document.createElement("treecell");
		tcelltype.setAttribute("label", type);
		trow.appendChild(tcell);
		trow.appendChild(tcelltype);
		titem.appendChild(trow);
		children.appendChild(titem);
		
	},
	loadPredicate:function(item)
	{
		var rsc=this.RdfService.GetResource(item.firstChild.firstChild.attributes.getNamedItem("label").value);
		var predi=this.DataSource.ArcLabelsOut(rsc);
		while(predi.hasMoreElements())
		{
			var p=predi.getNext();
			if (p instanceof Components.interfaces.nsIRDFResource)
			{	
				this.appendItem(item,p.Value,this.strPredicate);
			}
		}
	},	
	loadTarget:function(item)
	{
		var rscuri=item.parentNode.parentNode.firstChild.firstChild.attributes.getNamedItem("label").value;
		var rsc=this.RdfService.GetResource(rscuri);
		var prd=this.RdfService.GetResource(item.firstChild.firstChild.attributes.getNamedItem("label").value);
		var targets=this.DataSource.GetTargets(rsc,prd,true);
		while(targets.hasMoreElements())
		{
			var target=targets.getNext();
	        if (target instanceof Components.interfaces.nsIRDFResource)
	            this.appendItem(item,target.Value,this.strResource);
			else
			if (target instanceof Components.interfaces.nsIRDFLiteral)
	            this.appendItem(item,target.Value,this.strLiteral);
			else
			if (target instanceof Components.interfaces.nsIRDFBlob)
	            this.appendItem(item,target.Value,this.strBlob);
			else
			if (target instanceof Components.interfaces.nsIRDFInt)
	            this.appendItem(item,target.Value,this.strInt);
			else
			if (target instanceof Components.interfaces.nsIRDFDate)
	            this.appendItem(item,new Date(target.Value/1000).toLocaleString(),this.strDate);
			else
			if (target instanceof Components.interfaces.nsIRDFNode)
	            this.appendItem(item,target.Value,this.strNode);
			else
	            this.appendItem(item,target.Value,this.strUnknown);
		}
	},
	load:function(aEvent)
	{
		var treeview=document.getElementById("TreeView");
		var tbo = treeview.treeBoxObject;
		var t=tbo.getRowAt(aEvent.clientX, aEvent.clientY);
		 if (t>=0)
		 {
			var view=treeview.contentView; 
			var elem = view.getItemAtIndex(t);
			//dump(elem.attributes.getNamedItem("type").value+"\n");
			if(!elem.attributes.getNamedItem("loaded"))
			{
				switch(elem.attributes.getNamedItem("type").value)
				{
				case this.strResource:
					this.loadPredicate(elem);
					break;
				case this.strPredicate:
					this.loadTarget(elem);
					break;
				}
				elem.setAttribute("loaded","true");
			}
		}
	}
}